



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Cocos2d-x 3.X 事件分发机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Cocos2d-x 3.X 事件分发机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 07:21:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>介绍</h1>
<p>Cocos2d-X 3.X 引入了一种新的响应用户事件的机制。</p>
<p>涉及三个基本的方面：</p>
<ul><li>Event listeners 封装你的事件处理代码</li>
<li>Event dispatcher 向 listener 分发用户事件</li>
<li>Event 对象 包含关于事件的信息</li></ul>
<p>为了响应事件，首先你要创建一个 EventListener，有五种不同的 EventListener.</p>
<ul><li>EventListenerTouch 响应触控事件</li>
<li>EventListenerKeyboard 响应键盘事件</li>
<li>EventListenerAcceleration 响应加速器事件</li>
<li>EventListenMouse 响应鼠标事件</li>
<li>EventListenerCustom 响应定制的事件</li></ul>
<p>然后，将你的时间处理代码连接到适当的事件监听回调方法中。（ 例如 EventListenerTouch 的 onTouchBegan ，或者 EventListenerKeyboard 的 onKeyPressed ）</p>
<p>接着，使用 EventDispatcher 注册你的 EventListener。</p>
<p>当事件触发之后 ( 例如，用户触摸了屏幕，或者敲击乐键盘 )，EventDispatcher 通过调用适当的 EventListener 的回调来分发 Event 对象 ( 例如 EventTouch, 或者 EventKeyboard ），每个事件对象包含对应的事件信息 ( 例如包含触控的坐标 )。</p>
<h1>示例</h1>
<p>在下面的代码中，我们在场景中添加三个按钮，每一个都可以响应触控事件。</p>
<div>
<pre class="prettyprint linenums">auto sprite1 = Sprite::create("Images/CyanSquare.png");<br />
sprite1-&gt;setPosition(origin+Point(size.width/, size.height/) + Point(-, ));<br />
addChild(sprite1, );

auto sprite2 = Sprite::create("Images/MagentaSquare.png");<br />
sprite2-&gt;setPosition(origin+Point(size.width/, size.height/));<br />
addChild(sprite2, );

auto sprite3 = Sprite::create("Images/YellowSquare.png");<br />
sprite3-&gt;setPosition(Point(, ));<br />
sprite2-&gt;addChild(sprite3, );  </pre>
</div>
<p>如图所示</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/13475/201406/122236547333986.png" /></p>
<h1>创建一个触控的事件监听器和回调代码</h1>
<p>（注意，在下面的代码中，我们使用 C++11 的 Lambda 表达式来实现回调，后面的键盘事件使用另外一种方式，使用 CC_CALLBACK_N 宏来实现）</p>
<div>
<pre class="prettyprint linenums">// 创建一个排队的触控事件监听器 ( 同时仅仅处理一个触控事件 )<br />
auto listener = EventListenerTouchOneByOne::create();<br />
// 当 "swallow touches" 设置为 true, 然后，在 onTouchBegan 方法发返回 'true' 将会吃掉触控事件, 防止其他监听器使用这个事件.<br />
listener-&gt;setSwallowTouches(true);

// 使用 lambda 表达式实现 onTouchBegan 事件的回调函数<br />
listener-&gt;onTouchBegan = [](Touch* touch, Event* event){<br />
    // event-&gt;getCurrentTarget() 返回 *listener's* sceneGraphPriority 节点.<br />
    auto target = static_cast&lt;Sprite*&gt;(event-&gt;getCurrentTarget());

    // 获取当前触控点相对与按钮的位置<br />
    Point locationInNode = target-&gt;convertToNodeSpace(touch-&gt;getLocation());<br />
    Size s = target-&gt;getContentSize();<br />
    Rect rect = Rect(, , s.width, s.height);

    // 检测点击区域<br />
    if (rect.containsPoint(locationInNode))<br />
    {<br />
        log("sprite began... x = %f, y = %f", locationInNode.x, locationInNode.y);<br />
        target-&gt;setOpacity();<br />
        return true;<br />
    }<br />
    return false;<br />
};

// 当移动触控的时候<br />
listener-&gt;onTouchMoved = [](Touch* touch, Event* event){<br />
    auto target = static_cast&lt;Sprite*&gt;(event-&gt;getCurrentTarget());<br />
    // 移动当前的精灵<br />
    target-&gt;setPosition(target-&gt;getPosition() + touch-&gt;getDelta());<br />
};

// 结束<br />
listener-&gt;onTouchEnded = [=](Touch* touch, Event* event){<br />
    auto target = static_cast&lt;Sprite*&gt;(event-&gt;getCurrentTarget());<br />
    log("sprite onTouchesEnded.. ");<br />
    target-&gt;setOpacity();<br />
    //重新设置 zOrder，改变现实顺序<br />
    if (target == sprite)<br />
    {<br />
        sprite-&gt;setZOrder();<br />
    }<br />
    else if (target == sprite)<br />
    {<br />
        sprite-&gt;setZOrder();<br />
    }<br />
};</pre>
</div>
<h1>添加事件监听器到事件分发器</h1>
<div>
<pre class="prettyprint linenums">// 注册监听器<br />
_eventDispatcher-&gt;addEventListenerWithSceneGraphPriority(listener1, sprite1);<br />
_eventDispatcher-&gt;addEventListenerWithSceneGraphPriority(listener1-&gt;clone(), sprite2);<br />
_eventDispatcher-&gt;addEventListenerWithSceneGraphPriority(listener1-&gt;clone(), sprite3);</pre>
</div>
<p>_eventDispatcher 是 Node 的属性，我们使用它来管理当前节点的所有事件分发 ( 还有像 Scene, Layer, Sprite 等等 )。</p>
<p>注意，在上面的例子中，我们在调用第二和第三个 addEventListenerWithSceneGraphPriority&nbsp; 中使用 clone() 方法，这是因为每个事件监听器只能被添加一次。addEventListenerWithSceneGraphPriority 方法和&nbsp;<code>addEventListenerWithFixedPriority</code>&nbsp; 在事件监听器中设置一个注册标志，如果已经设置了标志，就不能再次添加了。</p>
<p>还有需要记住的就是，如果你添加了一个&nbsp;_fixed priority_ listener 到节点，当节点被删除的时候，你需要手动删除这个监听器，而绑定到节点的&nbsp;_scene graph priority_ listener，当节点被析构的时候，监听器将会被自动析构。</p>
<h1>新的触控机制</h1>
<p>上面的处理过程与 2.X版本比较，看起来比较难，在旧版中，你需要从 delegate 类派生，其中定义了 onTouchBegan 等等方法，你的事件处理代码会放到这些委托方法中。</p>
<p>新的事件处理机制将事件处理逻辑从 delegate 中移到了监听器中，上面的逻辑实现了如下功能。</p>
<ol><li>通过使用事件监听器，精灵可以使用 SceneGraphPriority 添加到事件分发器，也就是说，当点击精灵的时候，回调函数可以以显示的顺序来调用。( 也就是说，显示在前面的精灵优先得到事件 )</li>
<li>当处理事件逻辑的时候，基于不同的状况来处理触控的逻辑 ( 比如），显示点击的效果。</li>
<li>由于&nbsp;<code>listener1-&gt;setSwallowTouches(true)</code>&nbsp; 设置了，还有在 onTouchBegan 中的处理逻辑，不管何种显示顺序都可以被处理。</li></ol>
<h1>FixedPriority 对 SceneGraphPriority</h1>
<p>EventDispatcher 使用优先级来决定监听器对事件的分发。</p>
<p>FixedPriority ，一个整数，低的 EventListeners 优先高的 EventListenters.</p>
<p>SceneGraphPriority ，一个节点的指针，高的 Z Order 的节点优先于低的 Z Order 节点，这样确保前面的元素获取触控事件。</p>
<h1>其它事件处理模式</h1>
<p>下面代码使用另外的机制。</p>
<p>你也可以使用 CC_CALLBACK_N 宏来实现类似机制，下面的代码演示键盘处理。</p>
<div>
<pre class="prettyprint linenums">    // 创建键盘监听器<br />
    auto listener = EventListenerKeyboard::create();<br />
    listener-&gt;onKeyPressed = CC_CALLBACK_2(KeyboardTest::onKeyPressed, this);<br />
    listener-&gt;onKeyReleased = CC_CALLBACK_2(KeyboardTest::onKeyReleased, this);

    _eventDispatcher-&gt;addEventListenerWithSceneGraphPriority(listener, this);

    // 实现键盘回调的宏<br />
    void KeyboardTest::onKeyPressed(EventKeyboard::KeyCode keyCode, Event* event)<br />
    {<br />
        log("Key with keycode %d pressed", keyCode);<br />
    }

    void KeyboardTest::onKeyReleased(EventKeyboard::KeyCode keyCode, Event* event)<br />
    {<br />
        log("Key with keycode %d released", keyCode);<br />
    }   </pre>
</div>
<h1>Accelerometer 事件</h1>
<p>在使用加速器事件之前，需要在设备上启用加速器。</p>
<div>
<pre class="prettyprint linenums">Device::setAccelerometerEnabled(true);</pre>
</div>
<p>使用监听器</p>
<div>
<pre class="prettyprint linenums">    auto listener = EventListenerAcceleration::create(CC_CALLBACK_2(AccelerometerTest::onAcceleration, this));<br />
    _eventDispatcher-&gt;addEventListenerWithSceneGraphPriority(listener, this);

    // 实现回调函数<br />
    void AccelerometerTest::onAcceleration(Acceleration* acc, Event* event)<br />
    {<br />
        //  Processing logic here<br />
    }</pre>
</div>
<h1>鼠标事件</h1>
<p>在 V3.0 中添加了鼠标点击事件分发，支持多平台，丰富了用户的游戏体验。</p>
<p>与所有的事件类型一样，首先需要创建事件监听器</p>
<div>
<pre class="prettyprint linenums">    _mouseListener = EventListenerMouse::create();<br />
    _mouseListener-&gt;onMouseMove = CC_CALLBACK_1(MouseTest::onMouseMove, this);<br />
    _mouseListener-&gt;onMouseUp = CC_CALLBACK_1(MouseTest::onMouseUp, this);<br />
    _mouseListener-&gt;onMouseDown = CC_CALLBACK_1(MouseTest::onMouseDown, this);<br />
    _mouseListener-&gt;onMouseScroll = CC_CALLBACK_1(MouseTest::onMouseScroll, this);

    _eventDispatcher-&gt;addEventListenerWithSceneGraphPriority(_mouseListener, this);</pre>
</div>
<p>然后，一个一个实现监听器的回调函数</p>
<div>
<pre class="prettyprint linenums">void MouseTest::onMouseDown(Event *event)<br />
{<br />
    EventMouse* e = (EventMouse*)event;<br />
    string str = "Mouse Down detected, Key: ";<br />
    str += tostr(e-&gt;getMouseButton());<br />
    // ...<br />
}

void MouseTest::onMouseUp(Event *event)<br />
{<br />
    EventMouse* e = (EventMouse*)event;<br />
    string str = "Mouse Up detected, Key: ";<br />
    str += tostr(e-&gt;getMouseButton());<br />
    // ...<br />
}

void MouseTest::onMouseMove(Event *event)<br />
{<br />
    EventMouse* e = (EventMouse*)event;<br />
    string str = "MousePosition X:";<br />
    str = str + tostr(e-&gt;getCursorX()) + " Y:" + tostr(e-&gt;getCursorY());<br />
    // ...<br />
}

void MouseTest::onMouseScroll(Event *event)<br />
{<br />
    EventMouse* e = (EventMouse*)event;<br />
    string str = "Mouse Scroll detected, X: ";<br />
    str = str + tostr(e-&gt;getScrollX()) + " Y: " + tostr(e-&gt;getScrollY());<br />
    // ...<br />
}</pre>
</div>
<h1>定制事件</h1>
<p>上面的事件是系统定义的事件，事件由系统自动触发，额外的，你也可以定制不是由系统自动触发的事件，通过你自己的代码来实现。</p>
<div>
<pre class="prettyprint linenums">    _listener = EventListenerCustom::create("game_custom_event1", [=](EventCustom* event){<br />
        std::string str("Custom event 1 received, ");<br />
        char* buf = static_cast&lt;char*&gt;(event-&gt;getUserData());<br />
        str += buf;<br />
        str += " times";<br />
        statusLabel-&gt;setString(str.c_str());<br />
    });

    _eventDispatcher-&gt;addEventListenerWithFixedPriority(_listener, );</pre>
</div>
<p>自定义的事件监听器如上所示，有响应代码，添加到事件分发器，如何触发呢？看下面。</p>
<div>
<pre class="prettyprint linenums">    static int count = ;<br />
    ++count;

    char* buf = new char[];<br />
    sprintf(buf, "%d", count);

    EventCustom event("game_custom_event1");<br />
    event.setUserData(buf);

    _eventDispatcher-&gt;dispatchEvent(&amp;event);

    CC_SAFE_DELETE_ARRAY(buf);</pre>
</div>
<p>上面的代码创建了一个 EventCustom 对象，设置了用户数据，通过手工调用 _eventDispatcher 的 dispatchEvent 方法触发，这就会触发前面定义的处理器。</p>
<h1>删除事件监听器</h1>
<p>已经添加的事件监听器可以如下删除。</p>
<div>
<pre class="prettyprint linenums">_eventDispatcher-&gt;removeEventListener(listener);</pre>
</div>
<p>使用下面的代码，删除所有的事件监听器。</p>
<div>
<pre class="prettyprint linenums">_eventDispatcher-&gt;removeAllEventListeners();</pre>
</div>
<p>当掉用 removeAllEventListeners 的时候，这个节点所有的监听器都被删除了，建议删除特定的监听器。</p>
<p>注意，当调用 removeAll 之后，菜单会停止响应，因为它也需要接收触控事件。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2mjk38.html">monkey命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93d4er8.html">django关系对象映射（Object Relational Mapping，简称ORM）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mw07oq.html">tokudb引擎磁盘空间不足导致写入失败的调查</a>
		</li>
						<li><a href="https://www.batexi.com/a/49545weq.html">BurpSuite之SQL Injection</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwddkm38.html">weblogic解密工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvvmeoq.html">MVC 与传统的 webform 的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v46r9.html">XCODE 出现 The operation couldn&amp;&num;39&semi;t be completed&period;&lpar;LaunchServicesError error 0&period;&rpar;错误修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k14ekj9.html">机器人api（图灵机器人）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeywov9.html">The working copy xxxx needs to be upgraded to Subversion 1&period;7&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z10pjn9.html">Java中的随机数生成器：Random，ThreadLocalRandom，SecureRandom（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zo5m19.html">轻量级验证码生成插件webutil-licenseImage</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geg1478.html">枚举：enum&mdash;&mdash;初写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg617q.html">C&num; 如何添加Word文本和图片超链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7pwr9.html">使用Android服务，实现报警管理器和广播接收器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1k20dq.html">专注于C&num;&period;Net WPF软件开发-软件反编译-软件破解-逆向-靖芯科技-包括安卓APK反编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj356z8.html">马拉车算法&mdash;&mdash;poj3974</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jom1x8.html">前端笔记之JavaScript（六）让人头疼的正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1523lq.html">简单（基本）的风光摄影照片后期处理-新手教程-ps照片后期基本处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6zm58.html">iOS 开发笔记-NSURLConnection的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5vk19.html">vue导出excel数据表格功能</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4pmo3q.html">Java调优知识汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql1n609.html">错误解决：error while loading shared libraries&colon; libcurl&period;so&period;4&colon; cannot open  shared object file&colon; No such file or directory</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1vjm2q.html">Android应用开发基础之十二：版本控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96355v9.html">敏捷开发XP</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96352j9.html">vimrc</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyvrnjq.html">Maven基础配置&mdash;本地Maven配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1vlk2q.html">Linux下Oracle 10&period;2&period;0&period;1升级到10&period;2&period;0&period;4总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/3902pxoq.html">winform（四）&mdash;&mdash;简单计算器制作</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1v475q.html">利用 spring bean 的属性 init-method 解决因为数据库连接没有初始化而导致首次点击页面超慢的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963l139.html">jQuery validator自定义</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
